"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.DELAY = void 0;

var _react = require("react");

var _scope = require("./scope");

const DELAY = 100;
exports.DELAY = DELAY;

const useSocketInstance = url => {
  const [socket, setSocket] = (0, _react.useState)(null);
  const acquireScopedSocket = (0, _scope.useSocketScope)();
  (0, _react.useEffect)(() => {
    let s, t;

    if (url) {
      t = setTimeout(() => {
        if (acquireScopedSocket) {
          s = acquireScopedSocket(url);
        } else {
          s = new WebSocket(url);
        }

        setSocket(s);
        t = null;
      }, DELAY);
    }

    return () => {
      if (t) {
        clearTimeout(t);
      }

      if (s) {
        if (s.release) {
          s.release(url);
        } else {
          s.close();
        }
      }
    };
  }, [acquireScopedSocket, url]);
  return socket;
};

var _default = useSocketInstance;
exports.default = _default;