"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = require("react");

var _openHandler = _interopRequireDefault(require("./open-handler"));

var _sendHandler = _interopRequireDefault(require("./send-handler"));

var _socketInstance = _interopRequireDefault(require("./socket-instance"));

var _messageHandler = _interopRequireDefault(require("./message-handler"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const useMessageQueue = () => (0, _react.useRef)([]);

const useSocket = (url, {
  onMessage
} = {}) => {
  const messageQueue = useMessageQueue();
  const socket = (0, _socketInstance.default)(url);
  const send = (0, _sendHandler.default)({
    socket,
    messageQueue
  });
  (0, _openHandler.default)({
    messageQueue,
    send,
    socket
  });
  (0, _messageHandler.default)({
    socket,
    onMessage
  });
  return {
    send
  };
};

var _default = useSocket;
exports.default = _default;